regina::NRay Class Reference
Mathematical Support

A fast class for storing a ray rooted at the origin whose coordinates are rational. More...

`#include <maths/nray.h>`

Inheritance diagram for regina::NRay:

## Public Member Functions

| NRay (size_t length)
| Creates a new ray all of whose coordinates are initialised to zero. More...
| NRay (const NVector< NLargeInteger > &cloneMe)
| Creates a new ray that is a clone of the given ray. More...
void | scaleDown ()
| Scales this vector down by the greatest common divisor of all its elements. More...
void | negate ()
| Negates every element of this vector. More...
size_t | size () const
| Returns the number of elements in the vector. More...
const NLargeInteger & | operator[] (size_t index) const
| Returns the element at the given index in the vector. More...
void | setElement (size_t index, const NLargeInteger &value)
| Sets the element at the given index in the vector to the given value. More...
bool | operator== (const NVector< NLargeInteger > &compare) const
| Determines if this vector is equal to the given vector. More...
void | operator+= (const NVector< NLargeInteger > &other)
| Adds the given vector to this vector. More...
void | operator-= (const NVector< NLargeInteger > &other)
| Subtracts the given vector from this vector. More...
void | operator*= (const NLargeInteger &factor)
| Multiplies this vector by the given scalar. More...
NLargeInteger | operator* (const NVector< NLargeInteger > &other) const
| Calculates the dot product of this vector and the given vector. More...
NLargeInteger | norm () const
| Returns the norm of this vector. More...
NLargeInteger | elementSum () const
| Returns the sum of all elements of this vector. More...
void | addCopies (const NVector< NLargeInteger > &other, const NLargeInteger &multiple)
| Adds the given multiple of the given vector to this vector. More...
void | subtractCopies (const NVector< NLargeInteger > &other, const NLargeInteger &multiple)
| Subtracts the given multiple of the given vector to this vector. More...

## Static Public Attributes

static NLargeInteger | zero
| Zero in the underlying number system. More...
static NLargeInteger | one
| One in the underlying number system. More...
static NLargeInteger | minusOne
| Negative one in the underlying number system. More...

## Protected Attributes

NLargeInteger * | elements
| The internal array containing all vector elements. More...
NLargeInteger * | end
| A pointer just beyond the end of the internal array. More...

## Detailed Description

A fast class for storing a ray rooted at the origin whose coordinates are rational.

Such a ray is a half-line beginning at the origin and is represented by an integer point that it passes through. Positive scalar multiples of a ray are considered to represent the same ray.

This class is intended for serious computation, and as a result it has a streamlined implementation with no virtual methods. It can be subclassed, but since there are no virtual methods, type information must generally be known at compile time. Nevertheless, in many respects, different subclasses of NRay can happily interact with one another.

Warning
  As of Regina 4.90, this class merges the old functionality of NFastRay and NRay from Regina 4.6. Since functions are no longer virtual, the old clone() method and intersect() function are gone completely. Instead you can just use the copy constructor and standard linear operators respectively.

Python:
  Not present.

## Constructor & Destructor Documentation

regina::NRay::NRay | ( | size_t | length | ) |

inline

Creates a new ray all of whose coordinates are initialised to zero.

Parameters

  length | the number of elements in the new vector.

regina::NRay::NRay | ( | const NVector< NLargeInteger > & | cloneMe | ) |

inline

Creates a new ray that is a clone of the given ray.

Parameters

  cloneMe | the ray to clone.

## Member Function Documentation

void regina::NVector< NLargeInteger >::addCopies | ( | const NVector< NLargeInteger > & | other,
|  | const NLargeInteger & | multiple
| ) |  |

inline inherited

Adds the given multiple of the given vector to this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector a multiple of which will be added to this vector.
  multiple | the multiple of other to be added to this vector.

NLargeInteger regina::NVector< NLargeInteger >::elementSum | ( |  | ) | const

inline inherited

Returns the sum of all elements of this vector.

Returns
  the sum of the elements of this vector.

void regina::NRay::negate | ( |  | ) |

inline

Negates every element of this vector.

This is an optimised implementation that overrides NVector<NLargeInteger>::negate().

NLargeInteger regina::NVector< NLargeInteger >::norm | ( |  | ) | const

inline inherited

Returns the norm of this vector.

This is the dot product of the vector with itself.

Returns
  the norm of this vector.

NLargeInteger regina::NVector< NLargeInteger >::operator* | ( | const NVector< NLargeInteger > & | other | ) | const

inline inherited

Calculates the dot product of this vector and the given vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector with which this will be multiplied.

Returns
  the dot product of this and the given vector.

void regina::NVector< NLargeInteger >::operator*= | ( | const NLargeInteger & | factor | ) |

inline inherited

Multiplies this vector by the given scalar.

Parameters

  factor | the scalar with which this will be multiplied.

void regina::NVector< NLargeInteger >::operator+= | ( | const NVector< NLargeInteger > & | other | ) |

inline inherited

Adds the given vector to this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector to add to this vector.

void regina::NVector< NLargeInteger >::operator-= | ( | const NVector< NLargeInteger > & | other | ) |

inline inherited

Subtracts the given vector from this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector to subtract from this vector.

bool regina::NVector< NLargeInteger >::operator== | ( | const NVector< NLargeInteger > & | compare | ) | const

inline inherited

Determines if this vector is equal to the given vector.

Precondition
  This and the given vector have the same size.

Parameters

  compare | the vector with which this will be compared.

Returns
  `true` if and only if the this and the given vector are equal.

const NLargeInteger & regina::NVector< NLargeInteger >::operator[] | ( | size_t | index | ) | const

inline inherited

Returns the element at the given index in the vector.

A constant reference to the element is returned; the element may not be altered.

Precondition
  `index` is between 0 and size()-1 inclusive.

Parameters

  index | the vector index to examine.

Returns
  the vector element at the given index.

void regina::NRay::scaleDown | ( |  | ) |

Scales this vector down by the greatest common divisor of all its elements.

The resulting vector will be the smallest multiple of the original that maintains integral entries, and these entries will have the same signs as the originals.

This routine thus reduces a ray to its smallest possible representation.

This routine poses no problem for vectors containing infinite elements; such elements are simply ignored and left at infinity.

void regina::NVector< NLargeInteger >::setElement | ( | size_t | index,
|  | const NLargeInteger & | value
| ) |  |

inline inherited

Sets the element at the given index in the vector to the given value.

Precondition
  `index` is between 0 and size()-1 inclusive.

Parameters

  index | the vector index to examine.
  value | the new value to assign to the element.

Returns
  the vector element at the given index.

size_t regina::NVector< NLargeInteger >::size | ( |  | ) | const

inline inherited

Returns the number of elements in the vector.

Returns
  the vector size.

void regina::NVector< NLargeInteger >::subtractCopies | ( | const NVector< NLargeInteger > & | other,
|  | const NLargeInteger & | multiple
| ) |  |

inline inherited

Subtracts the given multiple of the given vector to this vector.

Precondition
  This and the given vector have the same size.

Parameters

  other | the vector a multiple of which will be subtracted from this vector.
  multiple | the multiple of other to be subtracted from this vector.

## Member Data Documentation

NLargeInteger * regina::NVector< NLargeInteger >::elements

protected inherited

The internal array containing all vector elements.

NLargeInteger * regina::NVector< NLargeInteger >::end

protected inherited

A pointer just beyond the end of the internal array.

The size of the vector can be computed as (end - elements).

NLargeInteger regina::NVector< NLargeInteger >::minusOne

static inherited

Negative one in the underlying number system.

This would be `const` if it weren't for the fact that some compilers don't like this. It should never be modified!

NLargeInteger regina::NVector< NLargeInteger >::one

static inherited

One in the underlying number system.

This would be `const` if it weren't for the fact that some compilers don't like this. It should never be modified!

NLargeInteger regina::NVector< NLargeInteger >::zero

static inherited

Zero in the underlying number system.

This would be `const` if it weren't for the fact that some compilers don't like this. It should never be modified!

The documentation for this class was generated from the following file:

- maths/nray.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).